var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import PropTypes from 'prop-types';
import { connect } from 'react-redux';
import { actionTypes } from 'redux-resource';
import { Fetch } from 'react-request';
import Resources from './resources';

export var ResourceRequest = function (_Component) {
  _inherits(ResourceRequest, _Component);

  function ResourceRequest() {
    _classCallCheck(this, ResourceRequest);

    return _possibleConstructorReturn(this, (ResourceRequest.__proto__ || Object.getPrototypeOf(ResourceRequest)).apply(this, arguments));
  }

  _createClass(ResourceRequest, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          request = _props.request,
          _children = _props.children,
          resourceName = _props.resourceName,
          transformData = _props.transformData,
          crudAction = _props.crudAction,
          resources = _props.resources,
          dispatch = _props.dispatch,
          list = _props.list,
          mergeListIds = _props.mergeListIds,
          treatNullAsPending = _props.treatNullAsPending;


      var capitalizedCrudAction = crudAction.toUpperCase();

      return React.cloneElement(request, {
        beforeFetch: function beforeFetch(info) {
          var requestKey = info.requestKey;

          dispatch({
            resourceName: resourceName,
            resources: resources,
            type: actionTypes[capitalizedCrudAction + '_RESOURCES_PENDING'],
            request: requestKey
          });

          request.props.beforeFetch(info);
        },
        afterFetch: function afterFetch(info) {
          var requestKey = info.requestKey,
              data = info.data,
              response = info.response,
              error = info.error;

          var status = response && response.status || 0;
          if (error || status >= 400) {
            // This needs to be a more accurate check :)
            if (error && error.isAborted) {
              dispatch({
                resourceName: resourceName,
                resources: resources,
                type: actionTypes[capitalizedCrudAction + '_RESOURCES_NULL'],
                request: requestKey
              });
            } else {
              dispatch({
                resourceName: resourceName,
                resources: resources,
                statusCode: status,
                type: actionTypes[capitalizedCrudAction + '_RESOURCES_FAILED'],
                request: requestKey,
                error: error
              });
            }
          } else {
            var dispatchResources = void 0;
            if (data && transformData) {
              dispatchResources = transformData(data);
            } else if (data) {
              dispatchResources = data;
            } else {
              dispatchResources = resources;
            }
            dispatch({
              resourceName: resourceName,
              list: list,
              mergeListIds: mergeListIds,
              statusCode: status,
              type: actionTypes[capitalizedCrudAction + '_RESOURCES_SUCCEEDED'],
              request: requestKey,
              resources: dispatchResources
            });
          }

          request.props.afterFetch(info);
        },
        children: function children(renderProps) {
          function setFetchToIdle(actionAttributes) {
            return dispatch(_extends({
              type: actionTypes[capitalizedCrudAction + '_RESOURCES_NULL'],
              request: renderProps.requestKey,
              resourceName: resourceName,
              // Should `resources` be in here by default? I need to think more about
              // that.
              resources: resources
            }, actionAttributes));
          }
          return React.createElement(Resources, _extends({}, renderProps, {
            treatNullAsPending: treatNullAsPending,
            resourceName: resourceName,
            setFetchToIdle: setFetchToIdle,
            children: _children,
            list: list
          }));
          return;
        }
      });
    }
  }]);

  return ResourceRequest;
}(Component);

ResourceRequest.propTypes = {
  resourceName: PropTypes.string.isRequired,
  crudAction: PropTypes.string.isRequired,
  lists: PropTypes.arrayOf(PropTypes.string).isRequired
};

ResourceRequest.defaultProps = {
  lists: []
};

function mapDispatchToProps(dispatch) {
  return { dispatch: dispatch };
}

export default connect(null, mapDispatchToProps)(ResourceRequest);