'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRedux = require('react-redux');

var _reduxResource = require('redux-resource');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

class Resources extends _react.Component {
  render() {
    const _props = this.props,
          {
      children
    } = _props,
          otherProps = _objectWithoutProperties(_props, ['children']);

    return children(_extends({}, otherProps));
  }
}

// Although we have access to the request in the render callback,
// this subscribes us to updates to the store. So if another
// component makes a new HTTP call with this same request key,
// then this component will be updated as well.
function mapStateToProps(state, props) {
  const resourceSlice = state[props.resourceName] || {};
  const resourceRequests = resourceSlice.requests || {};
  const resourceMeta = resourceSlice.meta || {};
  const request = resourceRequests[props.requestKey] || {};
  const resourcesArray = (0, _reduxResource.getResources)(resourceSlice, request.ids);

  const status = (0, _reduxResource.getStatus)(request, 'status', props.treatNullAsPending);

  const resources = {};
  const meta = {};
  resourcesArray.map(resource => {
    meta[resource.id] = resourceMeta[resource.id];
    resources[resource.id] = resource;
  });

  // This prepares us for a future `lists` API.
  const lists = {
    [props.list]: (0, _reduxResource.getResources)(resourceSlice, resourceSlice.lists[props.list])
  };

  return {
    request,
    status,
    resources,
    meta,
    lists
  };
}

exports.default = (0, _reactRedux.connect)(mapStateToProps)(Resources);